## image-editor 6.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

project(imageeditor)

execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

set(CMAKE_C_FLAGS "-fPIC")
set(CMAKE_CXX_FLAGS "-fPIC")
set(CMAKE_EXPORT_COMPILE_COMMANDS on)
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# check Qt version, support Qt5 default
find_package(Qt6 QUIET)
if (Qt6_FOUND)
    set(SUPPORT_QT6 TRUE)
    set(QT_VERSION_MAJOR 6)
    set(DTK_VERSION_MAJOR 6)
    # libimageeditor major version
    set(IMGE_VERSION_MAJOR 6)
else()
    set(QT_VERSION_MAJOR 5)
endif()

find_package(PkgConfig REQUIRED)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})

add_subdirectory(libimageviewer)
add_subdirectory(libimagevisualresult)

option(DOTEST "option for test" OFF)
if(DOTEST OR CMAKE_BUILD_TYPE STREQUAL "Debug")
    # add_subdirectory(tests)
endif()

=== libimageviewer/CMakeLists.txt ===
if(SUPPORT_QT6)
    include(libimageviewer-qt6.cmake)
endif()

include(libimageviewer-qt5.cmake)

=== libimagevisualresult/CMakeLists.txt ===
if(SUPPORT_QT6)
    include(libimagevisualresult-qt6.cmake)
endif()


include(libimagevisualresult-qt5.cmake)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

project(image-editor-test VERSION 0.1)

ADD_COMPILE_OPTIONS(-fno-access-control)

#"option"用来定义宏，"ON"表示打开，"OFF"表示关闭
option(LITE_DIV "Use tutorial provided math implementation" ON)
add_definitions(-DLITE_DIV)

option(USE_TEST "Use TESTS" ON)
add_definitions(-DUSE_TEST)

ADD_COMPILE_OPTIONS(-fno-access-control)

set(TARGET_NAME image-editor-test)
set(CMD_NAME image-editor-test)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
#ADD_DEFINITIONS( -LITE_DIV)
execute_process(COMMAND uname -m OUTPUT_VARIABLE MACH
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)



if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 ")
endif()

# Sources files
#cmakedefine USE_MYMATH
set(AllTestQRC
    ./testqrc/testresource.qrc)
file(GLOB_RECURSE HEADERSCURRENT "*.h")
file(GLOB_RECURSE SOURCESCURRENT "*.cpp")

file(GLOB_RECURSE SOURCES
    "../libimageviewer/*.cpp"
    "../libimageviewer/*.h"
    "../libimagevisualresult/exposure.cpp"
    "../libimagevisualresult/exposure.h"
)
file(GLOB_RECURSE SOURCESC "../libimageviewer/*.c")
#file(GLOB_RECURSE HEADERS "../src/src/module/modulepanel.h")
file(GLOB_RECURSE FORMS "../libimageviewer/*.ui")
file(GLOB_RECURSE RESOURCES "../*.qrc")
# 三方库 tiff-tools tiffcp.c
file(GLOB tiffToolsSources ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/tiff-tools/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/tiff-tools/*.h)

include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROJECT_INCLUDE ${PROJECT_SOURCE_DIR}/../libimageviewer/
    ${PROJECT_SOURCE_DIR}/../src/src/utils
)

find_package(PkgConfig REQUIRED)
find_package(TIFF)

find_package(Qt5Core)
find_package(Qt5Test)
find_package(Qt5Gui)
find_package(Qt5Widgets)
find_package(Qt5Sql)
find_package(Qt5DBus)
find_package(Qt5Concurrent)
find_package(Qt5Svg)
find_package(Qt5X11Extras)
find_package(Qt5PrintSupport)
find_package(Qt5LinguistTools)

pkg_check_modules(3rd_lib REQUIRED
    dtkcore
    dtkwidget
    gstreamer-1.0
    libmediainfo
)

## translations

file(GLOB TS LIST_DIRECTORIES false translations/${CMD_NAME}*.ts)
#file(GLOB TS LIST_DIRECTORIES false ${PROJECT_SOURCE_DIR}/translations/image-editor_zh_CN.ts)

set_source_files_properties(${TS} PROPERTIES OUTPUT_LOCATION ${PROJECT_SOURCE_DIR}/translations)

qt5_create_translation(QM ${SOURCES} ${GLOB})

if(NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    qt5_create_translation(QM ${SRCS} ${TS})
endif()

add_executable(${TARGET_NAME} ${SOURCES} ${SOURCESC}
    ${HEADERS} ${AllTestQRC}
    ${RESOURCES} ${HEADERSCURRENT}
    ${SOURCESCURRENT} ${QM} ${tiffToolsSources}
)

# 暂未使用OpenCV, 暂时屏蔽
# find_package(OpenCV REQUIRED)
# include_directories(${OpenCV_INCLUDE_DIRS})
# link_directories(${OpenCV_LIBRARY_DIRS})
# target_link_libraries(${PROJECT_NAME} ${OpenCV_LIBS})

target_include_directories(${TARGET_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} ${PROJECT_INCLUDE} ${GLOB_RECURSE} ${TIFF_INCLUDE_DIRS})
target_link_libraries(${TARGET_NAME} ${3rd_lib_LIBRARIES} -ldl ${TIFF_LIBRARIES})


target_link_libraries(
    ${PROJECT_NAME}
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::Sql
    Qt5::Svg
    Qt5::DBus
    Qt5::Concurrent
    Qt5::X11Extras
    Qt5::PrintSupport
    Qt5::Test
    dtkwidget
    dtkcore
    X11
    Xext
    exif
    pthread
    gtest
)


include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})
#configure_file(${PROJECT_SOURCE_DIR}/config.h.in  @ONLY)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)


# 添加gocv覆盖率文件的输出
#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
# 加速编译优化参数
if(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage -pthread ")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -pthread ")
    set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE ON)

set(OBJECT_DIR ${CMAKE_BINARY_DIR}/CMakeFiles/objects)

add_custom_target(test
    COMMAND mkdir -p coverageResult
    COMMAND mkdir -p tests/test
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_command(TARGET test
    COMMAND echo " ===================CREAT LCOV REPROT==================== "
    COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ./tests/${PROJECT_NAME}
    COMMAND lcov --directory . --capture --output-file ./coverageResult/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./coverageResult/${PROJECT_NAME}_Coverage.info 'CMakeFiles/${PROJECT_NAME}.dir/${PROJECT_NAME}_autogen/*/*'
    '${PROJECT_NAME}_autogen/*/*' 'googletest/*/*' '*/usr/include/*' '*/tests/*' '/usr/local/*'
    -o ./coverageResult/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " =================== do filter end ==================== "

    COMMAND genhtml -o ./coverageResult/report ./coverageResult/${PROJECT_NAME}_Coverage_fileter.info
    COMMAND echo " -- Coverage files have been output to ${CMAKE_BINARY_DIR}/coverageResult/report "
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)
add_dependencies(test ${PROJECT_NAME})

=== debian/changelog ===
image-editor (6.5.1) unstable; urgency=medium

  * fix: support multi frame image load(Influence: quickprint)
  * test: Add initFFmpegVideoThumbnailer unit test.
          (Bug: 213565, 221557)(Influence: VideoThumbnailer)
  * test: update test image path
  * feat: [translation]add transifex config(Task: 361363)
  * fix: Update build configuration and dependencies

 -- renbin <renbin@uniontech.com>  Thu, 17 Apr 2025 13:23:01 +0800

image-editor (6.5.0) unstable; urgency=medium

  * fix: Use common method to check the version of dtkwidget
  * feat: support qt6.8

 -- renbin <renbin@uniontech.com>  Mon, 20 Jan 2025 10:25:26 +0800

=== debian/control ===
Source: image-editor
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: 
 debhelper (>= 11), 
 cmake, 
 pkg-config,
# Qt5
 qtbase5-dev,
 qtbase5-private-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtmultimedia5-dev,
 libqt5svg5-dev,
 libqt5x11extras5-dev,
# Qt6
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-multimedia-dev, 
 libqt6svg6-dev,
 libqt6opengl6-dev,
 libexif-dev, 
 libsqlite3-dev, 
 libxcb-util0-dev, 
 libstartup-notification0-dev,
 libraw-dev, 
 x11proto-xext-dev, 
 libmtdev-dev, 
 libegl1-mesa-dev,
 libudev-dev, 
 libfontconfig1-dev, 
 libfreetype6-dev, 
 libxrender-dev, 
# DTK
 libdtkwidget-dev,
 libdtkcore5-bin,
 libdtk6widget-dev,
 libdtk6core-bin,
 libmediainfo-dev,
 libffmpegthumbnailer-dev,
 libtiff-dev,
# Enable use dfm io to copy MTP mount file, Use `|`(or) relationship to 
# compatible different environments, hello will not be used.
# WARNING: control file changes may cause hello to be installed
# instead of libdfm-io-dev.
 libdfm6-io-dev | hello,
 libdfm-io-dev | hello
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

# Support Qt6
Package: libimageeditor6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 libimage-viewer
Replaces:
 libimage-viewer
Recommends: libqt6libqgtk2, kimageformat6-plugins, deepin-ocr, ffmpegthumbnailer, ffmpeg
Description: Image Viewer library.
 Deepin Image Viewer library.

Package: libimageeditor6-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libimageeditor6(=${binary:Version})
Conflicts:
 libimage-viewer-dev
Replaces:
 libimage-viewer-dev
Recommends: libqt6libgtk2, kimageformat6-plugins, deepin-ocr
Description: Image Viewer library development headers.
 Deepin Image Viewer library development headers.

# Support Qt5
Package: libimageeditor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 libimage-viewer
Replaces:
 libimage-viewer
Recommends: libqt5libqgtk2, kimageformat-plugins, deepin-ocr, ffmpegthumbnailer, ffmpeg
Description: Image Viewer library.
 Deepin Image Viewer library.

Package: libimageeditor-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libimageeditor(=${binary:Version})
Conflicts:
 libimage-viewer-dev
Replaces:
 libimage-viewer-dev
Recommends: libqt5libqgtk2, kimageformat-plugins, deepin-ocr
Description: Image Viewer library development headers.
 Deepin Image Viewer library development headers.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT=6
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build:
	dh_auto_build -- -j$(nproc)

## image-editor 6.5.2

=== debian/changelog ===
image-editor (6.5.2) unstable; urgency=medium

  * fix: Fix cppcheck warning

 -- re2zero <yangwu@uniontech.com>  Fri, 21 Nov 2025 08:50:06 +0800
